"""Dataclasses for all structs in the ERC4626Hyperdrive contract.

DO NOT EDIT.  This file was generated by pypechain.  See documentation at
https://github.com/delvtech/pypechain """

# super() call methods are generic, while our version adds values & types
# pylint: disable=arguments-differ

# contracts have PascalCase names
# pylint: disable=invalid-name
# contracts control how many attributes and arguments we have in generated code
# pylint: disable=too-many-instance-attributes
# pylint: disable=too-many-arguments
# unable to determine which imports will be used in the generated code
# pylint: disable=unused-import
# we don't need else statement if the other conditionals all have return,
# but it's easier to generate
# pylint: disable=no-else-return
from __future__ import annotations

from dataclasses import dataclass

from web3.types import ABIEvent, ABIEventParams

AddLiquidity = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="provider", type="address"),
        ABIEventParams(indexed=False, name="lpAmount", type="uint256"),
        ABIEventParams(indexed=False, name="baseAmount", type="uint256"),
        ABIEventParams(indexed=False, name="vaultShareAmount", type="uint256"),
        ABIEventParams(indexed=False, name="asBase", type="bool"),
        ABIEventParams(indexed=False, name="lpSharePrice", type="uint256"),
    ],
    name="AddLiquidity",
    type="event",
)

Approval = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="owner", type="address"),
        ABIEventParams(indexed=True, name="spender", type="address"),
        ABIEventParams(indexed=False, name="value", type="uint256"),
    ],
    name="Approval",
    type="event",
)

ApprovalForAll = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="account", type="address"),
        ABIEventParams(indexed=True, name="operator", type="address"),
        ABIEventParams(indexed=False, name="approved", type="bool"),
    ],
    name="ApprovalForAll",
    type="event",
)

CloseLong = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="trader", type="address"),
        ABIEventParams(indexed=True, name="destination", type="address"),
        ABIEventParams(indexed=True, name="assetId", type="uint256"),
        ABIEventParams(indexed=False, name="maturityTime", type="uint256"),
        ABIEventParams(indexed=False, name="baseAmount", type="uint256"),
        ABIEventParams(indexed=False, name="vaultShareAmount", type="uint256"),
        ABIEventParams(indexed=False, name="asBase", type="bool"),
        ABIEventParams(indexed=False, name="bondAmount", type="uint256"),
    ],
    name="CloseLong",
    type="event",
)

CloseShort = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="trader", type="address"),
        ABIEventParams(indexed=True, name="destination", type="address"),
        ABIEventParams(indexed=True, name="assetId", type="uint256"),
        ABIEventParams(indexed=False, name="maturityTime", type="uint256"),
        ABIEventParams(indexed=False, name="baseAmount", type="uint256"),
        ABIEventParams(indexed=False, name="vaultShareAmount", type="uint256"),
        ABIEventParams(indexed=False, name="asBase", type="bool"),
        ABIEventParams(indexed=False, name="basePayment", type="uint256"),
        ABIEventParams(indexed=False, name="bondAmount", type="uint256"),
    ],
    name="CloseShort",
    type="event",
)

CollectGovernanceFee = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="collector", type="address"),
        ABIEventParams(indexed=False, name="fees", type="uint256"),
    ],
    name="CollectGovernanceFee",
    type="event",
)

CreateCheckpoint = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="checkpointTime", type="uint256"),
        ABIEventParams(indexed=False, name="vaultSharePrice", type="uint256"),
        ABIEventParams(indexed=False, name="maturedShorts", type="uint256"),
        ABIEventParams(indexed=False, name="maturedLongs", type="uint256"),
        ABIEventParams(indexed=False, name="lpSharePrice", type="uint256"),
    ],
    name="CreateCheckpoint",
    type="event",
)

FeeCollectorUpdated = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="newFeeCollector", type="address"),
    ],
    name="FeeCollectorUpdated",
    type="event",
)

GovernanceUpdated = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="newGovernance", type="address"),
    ],
    name="GovernanceUpdated",
    type="event",
)

Initialize = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="provider", type="address"),
        ABIEventParams(indexed=False, name="lpAmount", type="uint256"),
        ABIEventParams(indexed=False, name="baseAmount", type="uint256"),
        ABIEventParams(indexed=False, name="vaultShareAmount", type="uint256"),
        ABIEventParams(indexed=False, name="asBase", type="bool"),
        ABIEventParams(indexed=False, name="apr", type="uint256"),
    ],
    name="Initialize",
    type="event",
)

OpenLong = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="trader", type="address"),
        ABIEventParams(indexed=True, name="assetId", type="uint256"),
        ABIEventParams(indexed=False, name="maturityTime", type="uint256"),
        ABIEventParams(indexed=False, name="baseAmount", type="uint256"),
        ABIEventParams(indexed=False, name="vaultShareAmount", type="uint256"),
        ABIEventParams(indexed=False, name="asBase", type="bool"),
        ABIEventParams(indexed=False, name="bondAmount", type="uint256"),
    ],
    name="OpenLong",
    type="event",
)

OpenShort = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="trader", type="address"),
        ABIEventParams(indexed=True, name="assetId", type="uint256"),
        ABIEventParams(indexed=False, name="maturityTime", type="uint256"),
        ABIEventParams(indexed=False, name="baseAmount", type="uint256"),
        ABIEventParams(indexed=False, name="vaultShareAmount", type="uint256"),
        ABIEventParams(indexed=False, name="asBase", type="bool"),
        ABIEventParams(indexed=False, name="baseProceeds", type="uint256"),
        ABIEventParams(indexed=False, name="bondAmount", type="uint256"),
    ],
    name="OpenShort",
    type="event",
)

PauseStatusUpdated = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=False, name="isPaused", type="bool"),
    ],
    name="PauseStatusUpdated",
    type="event",
)

PauserUpdated = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="newPauser", type="address"),
        ABIEventParams(indexed=False, name="status", type="bool"),
    ],
    name="PauserUpdated",
    type="event",
)

RedeemWithdrawalShares = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="provider", type="address"),
        ABIEventParams(indexed=True, name="destination", type="address"),
        ABIEventParams(indexed=False, name="withdrawalShareAmount", type="uint256"),
        ABIEventParams(indexed=False, name="baseAmount", type="uint256"),
        ABIEventParams(indexed=False, name="vaultShareAmount", type="uint256"),
        ABIEventParams(indexed=False, name="asBase", type="bool"),
    ],
    name="RedeemWithdrawalShares",
    type="event",
)

RemoveLiquidity = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="provider", type="address"),
        ABIEventParams(indexed=True, name="destination", type="address"),
        ABIEventParams(indexed=False, name="lpAmount", type="uint256"),
        ABIEventParams(indexed=False, name="baseAmount", type="uint256"),
        ABIEventParams(indexed=False, name="vaultShareAmount", type="uint256"),
        ABIEventParams(indexed=False, name="asBase", type="bool"),
        ABIEventParams(indexed=False, name="withdrawalShareAmount", type="uint256"),
        ABIEventParams(indexed=False, name="lpSharePrice", type="uint256"),
    ],
    name="RemoveLiquidity",
    type="event",
)

Sweep = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="collector", type="address"),
        ABIEventParams(indexed=True, name="target", type="address"),
    ],
    name="Sweep",
    type="event",
)

SweepCollectorUpdated = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="newSweepCollector", type="address"),
    ],
    name="SweepCollectorUpdated",
    type="event",
)

TransferSingle = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="operator", type="address"),
        ABIEventParams(indexed=True, name="from", type="address"),
        ABIEventParams(indexed=True, name="to", type="address"),
        ABIEventParams(indexed=False, name="id", type="uint256"),
        ABIEventParams(indexed=False, name="value", type="uint256"),
    ],
    name="TransferSingle",
    type="event",
)


@dataclass
class ErrorInfo:
    """Custom contract error information."""

    name: str
    selector: str
    signature: str
    inputs: list[ErrorParams]


@dataclass
class ErrorParams:
    """Parameter info for custom contract errors."""

    name: str
    solidity_type: str
    python_type: str


AddressEmptyCodeError = ErrorInfo(
    inputs=[
        ErrorParams(name="target", python_type="str", solidity_type="address"),
    ],
    name="AddressEmptyCode",
    selector="0x9996b315",
    signature="AddressEmptyCode(address)",
)

AddressInsufficientBalanceError = ErrorInfo(
    inputs=[
        ErrorParams(name="account", python_type="str", solidity_type="address"),
    ],
    name="AddressInsufficientBalance",
    selector="0xcd786059",
    signature="AddressInsufficientBalance(address)",
)

FailedInnerCallError = ErrorInfo(
    inputs=[],
    name="FailedInnerCall",
    selector="0x1425ea42",
    signature="FailedInnerCall()",
)

InvalidBaseTokenError = ErrorInfo(
    inputs=[],
    name="InvalidBaseToken",
    selector="0x0e442a4a",
    signature="InvalidBaseToken()",
)

ReentrancyGuardReentrantCallError = ErrorInfo(
    inputs=[],
    name="ReentrancyGuardReentrantCall",
    selector="0x3ee5aeb5",
    signature="ReentrancyGuardReentrantCall()",
)

SafeERC20FailedOperationError = ErrorInfo(
    inputs=[
        ErrorParams(name="token", python_type="str", solidity_type="address"),
    ],
    name="SafeERC20FailedOperation",
    selector="0x5274afe7",
    signature="SafeERC20FailedOperation(address)",
)

UnexpectedSuccessError = ErrorInfo(
    inputs=[],
    name="UnexpectedSuccess",
    selector="0x8bb0a34b",
    signature="UnexpectedSuccess()",
)
